<?php
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr 
 * @version 0.2.2
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.2
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


if ( ! defined( 'ABSPATH' ) ) 
        die( "Can't load this file directly" );

 
$loading = true;
$path = ini_get('include_path');
$ret = ini_set('include_path', dirname(__FILE__) . '/pear/'.PATH_SEPARATOR.$path);
if($ret){
	require_once(dirname(__FILE__) . '/pear/HTTP/Request.php');
}
else {
	printf('<h2>Impossible to load required libraries (PEAR and PEAR/HTTP/Request)!<br/> Please install this libraries in you php\'s share directory. </h2>');
	$loading=false;
}

class heiv_gallery_3 {
	private $pattern_css_photo = '
		<script type="text/javascript">
			function startGallery_%1$s() {
				$(\'%1$s\').style.height=\'%2$s\';
				$(\'%1$s\').style.width=\'%3$s\';
			}
			window.addEvent(\'domready\', startGallery_%1s);
		</script>';
	private $pattern_js_gallery= '
		<script type="text/javascript">
			function startGallery_%1$s() {
				var myGallery = new gallery($(\'%1$s\'), {
					timed: %4$s,
					delay: %5$s,
					showCarousel: %6$s,
					textShowCarousel: \'%7$s\',
					showInfopane: %8$s
				});
				$(\'%1$s\').style.height=\'%2$s\';
				$(\'%1$s\').style.width=\'%3$s\';
			}
			window.addEvent(\'domready\', startGallery_%1$s);
		</script>';
	private $ticket='';
	private $options = null;

	function __construct() {
		add_action( 'admin_init', array( $this, 'action_admin_init' ) );
		add_action( 'init', array( $this, 'action_init' ) );
		add_action('wp_head',array($this, 'header_init_css') );
		add_action('admin_menu',array($this,'config_admin_menu') );
		add_action('wp_ajax_heiv_gallery_3_populate_tree', array($this,'ajax_hg3_populate_tree_cb') );
		add_action('wp_ajax_heiv_gallery_3_test_config', array($this,'ajax_hg3_test_config_cb') );
		add_shortcode('hgallery3',array($this,'hg3_display') );
		
		$this->options = get_option('HeivGallery3PP');
		$url_baserest=sprintf('%s%s',$this->options['g3_host'], '/rest/');
//		if($this->options['g3_guest_access']==0 && $url_baserest!='')
//			$this->ticket = $this->options['g3_ticket_rest_api'];
			//$this->ticket = $this->get_ticket_g3($url_baserest,$this->options['g3_user'],$this->options['g3_passwd']);
	}

        function action_init() {
		// pas d'inclusion de mootools et de jd.gallery si on est en mode BE
		if(!strstr($_SERVER['REQUEST_URI'],'wp-admin')) {
			wp_deregister_script( 'mootools' );
			wp_register_script( 'mootools', plugin_dir_url(__FILE__) . 'js/mootools.v1.11.js');
			wp_enqueue_script('mootools');
			
			wp_deregister_script( 'jd_gallery' );
			wp_register_script( 'jd_gallery', plugin_dir_url(__FILE__) . 'js/jd.gallery.js',array('mootools'));
			wp_enqueue_script('jd_gallery');
		}
	}

	function header_init_css(){
		echo '<link type="text/css" rel="stylesheet" href="' . plugin_dir_url(__FILE__) . 'css/jd.gallery.css" />';
	}

        function action_admin_init() {
        // only hook up these filters if we're in the admin panel, and the current user has permission
        	if ( current_user_can( 'edit_posts' ) || current_user_can( 'edit_pages' ) ) {
			add_filter( 'mce_buttons', array($this,'filter_mce_button') );
			add_filter( 'mce_external_plugins', array($this,'filter_mce_plugin') );
			wp_enqueue_script( 'json2' );
		}
	 } 

	function config_admin_menu(){
		add_options_page('Gallery 3 Configuration','Gallery 3',9,basename(__FILE__),array($this,'admin_config_page') );
	}

	function filter_mce_button( $buttons ) {
		// add a separation before our button, here our button's id is &quot;mygallery_button&quot;
		array_push( $buttons, '|', 'heiv_gallery_3_button' );
		return $buttons;
	}

	function filter_mce_plugin( $plugins ) {
		// this plugin file will work the magic of our button
		$plugins['heiv_gallery_3'] = plugin_dir_url( __FILE__ ) . 'heiv_gallery_3_mce_editor.js';
		return $plugins;
	}
	
	function admin_config_page(){
		if ( isset($_POST['submit']) ) {
			if (!current_user_can('manage_options')) 
				die(__('You cannot edit the Gallery 3 options.'));

			$options = array();

			if (isset($_POST['g3_host']) && $_POST['g3_host'] != "")
				$options['g3_host']  = strtolower($_POST['g3_host']);

			if (isset($_POST['g3_user']) )
				$options['g3_user'] = $_POST['g3_user'];
			else {
				$options['g3_user']='';
			}

			if (isset($_POST['g3_guest_access']) )
				$options['g3_guest_access'] = $_POST['g3_guest_access']=='true';
			else {
				$options['g3_guest_access']=false;
			}

			if (isset($_POST['g3_passwd']))
				$g3_passwd = $_POST['g3_passwd'];
			else {
				$g3_passwd='';
			}

			if ( isset($_POST['g3_height']) && $_POST['g3_height'] != '' )
				$options['g3_height'] = intval($_POST['g3_height']);
			else
				$options['g3_height'] = 300 ;
			
			if ( isset($_POST['g3_width']) && $_POST['g3_width'] != '' )
				$options['g3_width'] = intval($_POST['g3_width']);
			else
				$options['g3_width'] = 200;

			if ( isset($_POST['g3_delay']) && $_POST['g3_delay'] != '' )
				$options['g3_delay'] = intval($_POST['g3_delay']);
			else
				$options['g3_delay'] = 5000;

			if (isset($_POST['g3_infoPane'])) {
				$options['g3_infoPane'] = 'true';
			} else {
				$options['g3_infoPane'] = 'false';
			}

			if (isset($_POST['g3_textCaroussel']) && trim($_POST['g3_textCaroussel'] != ""))
				$options['g3_textCaroussel'] = trim($_POST['g3_textCaroussel']);

			if (isset($_POST['g3_showCaroussel'])) {
				$options['g3_showCaroussel'] = 'true';
			} else {
				$options['g3_showCaroussel'] = 'false';
			}

			if (isset($_POST['g3_directlink'])) {
				$options['g3_directlink'] = 'true';
			} else {
				$options['g3_directlink'] = 'false';
			}

			if (isset($_POST['g3_timed'])) {
				$options['g3_timed'] = 'true';
			} else {
				$options['g3_timed'] = 'false';
			}
			
			if (isset($_POST['g3_target'])) {
				$options['g3_target'] = $_POST['g3_target'];
			} else {
				$options['g3_target'] = '_blank';
			}
			if (isset($_POST['g3_ticket_rest_api']) && $g3_passwd=='') {
				$options['g3_ticket_rest_api'] = $_POST['g3_ticket_rest_api'];
			}
			else {
				$url_baserest=sprintf('%s%s',$options['g3_host'], '/rest/');
				if($this->options['g3_guest_access']==0 && $url_baserest!='') {
					$options['g3_ticket_rest_api'] = $this->get_ticket_g3($url_baserest,$options['g3_user'],$g3_passwd);
				}
			}
			update_option('HeiVGallery3PP', $options);
			$this->options = null;
			$this->options = $options;
		}
		else
			$this->options = get_option('HeivGallery3PP');
	?>
		<div class="wrap">
			<script type="text/javascript">
				function help(ele1, ele2) {
					var expl = document.getElementById(ele2);
					if (expl.style.display == "block") {
						expl.style.display = "none";
						ele1.innerHTML = "(help)";
					} else {
						expl.style.display = "block";
						ele1.innerHTML = "(Hide help)";
					}
					return false;
				}
				function test_config_gallery3(){
					var host = jQuery('#g3_host').val();
					if(!host)
						host = '';
					var login='';
					var passwd='';
					var guest_access=jQuery('#g3_guest_access:checked').val();
					if(guest_access!='true'){
						login=jQuery('#g3_user').val();
						passwd=jQuery('#g3_passwd').val();
						if(!login)
							login='';
						if(!passwd)
							passwd='';
					}
					var data = { 
						host:host,
						guest:guest_access=='true',
						user:login,
						password:passwd,
						action: 'heiv_gallery_3_test_config'
					};
					jQuery.post(ajaxurl, data, function(response) {
						alert(response);
					});
				}

				function g3_set_guest() {
					var checkbox = jQuery("#g3_guest_access:checked").val();
					if(checkbox=='true'){
						jQuery("tr.ligne_no_guest").css('display','none');
					}
					else {
						jQuery("tr.ligne_no_guest").css('display','table-row');
					}
				}
			</script>

			<h2>Gallery 3 Configuration</h2>
			<form action="" method="post" id="heiv_g3_conf">
				<table class="form-table" style="width:100%;">
					<tr>
						<td style="width:30%;">
							<label for="g3_host">Fully qualified domain name of the Gallery 3 website</label><br/><small><a href="#" onclick="return help(this, 'help_host');">(help)</a></small>
						</td>
						<td style="width:70%;">
							<input name="g3_host" id="g3_host" type="text" value="<?php echo $this->options['g3_host'];?>" maxlength="99" size="80"/>
						</td>
					</tr>
					<tr id="help_host" style="display:none;border:1px solid grey;">
						<td colspan="2">
							For instance :
							<ul>
								<li>http://gallery3.mydomain.com/</li>
								<li>http://gallery3.myotherdomain.com/index.php/</li>
							</ul>
						</td>
					</tr>
<!--
					<tr>
						<td>
							<label for="g3_baseurl">Base URL of Gallery 3</label><br/><small><a href="#" onclick="return help(this, 'help_baseurl');">(help)</a></small>
						</td>
						<td>
							<input name="g3_baseurl" id="g3_baseurl" type="text" value="<?php echo $this->options['g3_baseurl']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_baseurl" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							by default it is "/index.php"
						</td>
					</tr>
-->
					<tr>
						<td>
							<label for="g3_user">Guest can query Gallery3 ?</label><br/><small><a href="#" onclick="return help(this, 'help_guest_access');">(help)</a></small>
						</td>
						<td>
							<input type="checkbox" name="g3_guest_access" id="g3_guest_access" value="true" onclick="g3_set_guest()" <?php if($this->options['g3_guest_access']=='true') echo ' checked="checked" '; ?>/>
						</td>
					</tr>
					<tr id="help_guest_access" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							In order to allow guest querying Restful's Gallery3, you have to read this documentation and apply the instructions : <a href="http://codex.gallery2.org/Gallery3:API:REST#Security_and_Authentication">Security and Authentication of Restful's Gallery3</a>
						</td>
					</tr>
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_user">User for querying Gallery 3 Restful</label><br/><small><a href="#" onclick="return help(this, 'help_user');">(help)</a></small>
						</td>
						<td>
							<input name="g3_user" id="g3_user" type="text" value="<?php echo $this->options['g3_user']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_user" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							User for querying Restful's Gallery3 website
						</td>
					</tr>
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_ticket_rest_api">Stored RESTFul API ticket</label><br/><small><a href="#" onclick="return help(this, 'help_ticket_rest_api');">(help)</a></small>
						</td>
						<td>
							<input name="g3_ticket_rest_api" id="g3_ticket_rest_api" type="text" value="<?php echo $this->options['g3_ticket_rest_api']; ?>" readonly="yes" size="40"/>
						</td>
					</tr>
					<tr id="help_ticket_rest_api" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							RESTFul API ticket will be used for query the RESTful Interface of Gallery3.<br/>If you want to change it, edit the user and the password and save the configuration.
						</td>
					</tr>	
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_passwd">Password for querying Gallery3 Restful</label><br/><small><a href="#" onclick="return help(this, 'help_passwd');">(help)</a></small>
						</td>
						<td>
							<input name="g3_passwd" id="g3_passwd" type="text" value="" maxlength="99" size="40"/>
						</td>
					<tr id="help_passwd" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							Password of the user who can query Restful's Gallery3 website.
							<b> The password isn't store on the WP database !</b>
						</td>
					</tr>
<?php
	if($this->options['g3_guest_access']=='true')
		printf('<script type="text/javascript">g3_set_guest()</script>');
?>
<!--
					<tr>
						<td>
							<label for="g3_baserest">Base URL of the restful acces of Gallery 3</label><br/><small><a href="#" onclick="return help(this, 'help_baserest');">(help)</a></small>
						</td>
						<td>
							<input name="g3_baserest" id="g3_baserest" type="text" value="<?php echo $this->options['g3_baserest']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_baserest" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							by default it is "/index.php/rest/item"
						</td>
					</tr>
-->
					<tr>
						<td>
							<label for="g3_height">Default height</label><br/><small><a href="#" onclick="return help(this, 'help_height');">(help)</a></small>
						</td>
						<td>
							<input name="g3_height" id="g3_height" type="text" value="<?php echo $this->options['g3_height']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_height" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							bla bla
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_width">Default width</label><br/><small><a href="#" onclick="return help(this, 'help_width');">(help)</a></small>
						</td>
						<td>
							<input name="g3_width" id="g3_width" type="text" value="<?php echo $this->options['g3_width']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_width" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							the height by default for display a picture or a album (in pixel(px))
						</td>
					</tr>
	<!-- futur feature
					<tr>
						<td>
							<label for="g3_curl">Use CURL</label><br/><small><a href="#" onclick="return help(this, 'help_curl');">(help)</a></small>
						</td>
						<td>
							<input name="g3_curl" id="g3_curl" type="text" value="<?php echo $this->options['g3_curl']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
	-->
					<tr id="help_curl" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							the width by default for display a picture or a album (in pixel (px))
						</td>
					</tr>
<!--
			'textCaroussel' => $options['g3_textCaroussel'], // 'Pictures'
			'infoPane' => $options['g3_infoPane'], // 'true'
-->
					<tr>
                                                <td>
                                                        <label for="g3_textCaroussel">Text of the Caroussel </label><br/><small><a href="#" onclick="return help(this, 'help_textCaroussel');">(help)</a></small>
                                                </td>
                                                <td>
                                                        <input name="g3_textCaroussel" id="g3_textCaroussel" type="text" value="<?php echo $this->options['g3_textCaroussel']; ?>" maxlength="99" size="40"/>
                                                </td>
                                        </tr>
                                        <tr id="help_textCaroussel" style="display:none;border:1px solid grey;">
                                                <td colspan="2">
                                                        Text of the caroussel
                                                </td>
                                        </tr>
					<tr>
                                                <td>
                                                        <label for="g3_showCaroussel">Show  caroussel </label><br/><small><a href="#" onclick="return help(this, 'help_showCaroussel');">(help)</a></small>
                                                </td>
                                                <td>
                                                        <input name="g3_showCaroussel" id="g3_showCaroussel" type="checkbox" <?php if($this->options['g3_showCaroussel']=='true') echo ' checked="checked" '; ?>/>
                                                </td>
                                        </tr>
                                        <tr id="help_showCaroussel" style="display:none;border:1px solid grey;">
                                                <td colspan="2">
                                                        If showCaroussel is checked, the caroussel is visible.
                                                </td>
                                        </tr>
					<tr>
                                                <td>
                                                        <label for="g3_infoPane">Image information panel</label><br/><small><a href="#" onclick="return help(this, 'help_infoPane');">(help)</a></small>
                                                </td>
                                                <td>
                                                        <input name="g3_infoPane" id="g3_infoPane" type="checkbox" <?php if($this->options['g3_infoPane']=='true') echo ' checked="checked" '; ?>/>
                                                </td>
                                        </tr>
                                        <tr id="help_infoPane" style="display:none;border:1px solid grey;">
                                                <td colspan="2">
                                                        Show or hide the image information panel
                                                </td>
                                        </tr>

                                        <tr>
                                                <td>
                                                        <label for="g3_timed">Timed caroussel </label><br/><small><a href="#" onclick="return help(this, 'help_timed');">(help)</a></small>
                                                </td>
                                                <td>
                                                        <input name="g3_timed" id="g3_timed" type="checkbox" <?php if($this->options['g3_timed']=='true') echo ' checked="checked" '; ?>/>
                                                </td>
                                        </tr>
                                        <tr id="help_timed" style="display:none;border:1px solid grey;">
                                                <td colspan="2">
                                                	If timed is checked, the picture will change automaticly
                                                </td>
                                        </tr>

                                       <tr>
                                                <td>
                                                        <label for="g3_delay">delay for Timed caroussel </label><br/><small><a href="#" onclick="return help(this, 'help_delay');">(help)</a></small>
                                                </td>
                                                <td>
                                                        <input name="g3_delay" id="g3_delay" type="text" value="<?php echo $this->options['g3_delay']; ?>" maxlength="99" size="40" />
                                                </td>
                                        </tr>
                                        <tr id="help_delay" style="display:none;border:1px solid grey;">
                                                <td colspan="2">
                                                        delay is milliseconds
                                                </td>
                                        </tr>


					<tr>
						<td>
							<label for="g3_directlink">Direct link to gallerys / pictures</label><br/><small><a href="#" onclick="return help(this, 'help_directlink');">(help)</a></small>
						</td>
						<td>
							<input type="checkbox" id="g3_directlink" name="g3_directlink" <?php if ($this->options['g3_directlink']=='true') echo ' checked="checked" '; ?>/>
						</td>
					</tr>
					<tr id="help_directlink" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							option which allow a visitor to go on the Gallery3 site
						</td>
					</tr>

					<tr>
						<td>
							<label for="g3_target">Target of the Direct link to gallerys / pictures</label><br/><small><a href="#" onclick="return help(this, 'help_target');">(help)</a></small>
						</td>
						<td>
							<select id="g3_target" name="g3_target">
								<option <?php if ($this->options['g3_target']=='_blank') echo 'selected="selected"'; ?> value="_blank">_blank</option>
								<option <?php if ($this->options['g3_target']=='_parent') echo 'selected="selected"'; ?> value="_parent">_parent</option>
								<option <?php if ($this->options['g3_target']=='_self') echo 'selected="selected"'; ?> value="_self">_self</option>
							</select> 
						</td>
					</tr>
					<tr id="help_target" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							open picture or album Gallery3 site :

<br/>    * _self => in the current page
<br/>    * _parent => in the parent page of the current page
<br/>    * _blank => in a new page

						</td>
					</tr>
				</table>
				<p style="border:0;" class="submit"><input type="button" name="test" value="Test Settings &raquo;" onclick="test_config_gallery3()"/>
				<input type="submit" name="submit" value="Update Settings &raquo;" /></p>
			</form>
		</div>

	<?php
	}

	function get_ticket_g3($url,$user,$pwd){
		$ticket='';
		if( $url!='' && $user!='' && $pwd!='') {

			$req = new HTTP_Request($url);

			$req->setMethod(HTTP_REQUEST_METHOD_POST);

			$req->addPostData('user',$user);
			$req->addPostData('password',$pwd);
			$req->addHeader('X-Gallery-Request-Method', 'post');

			$response = $req->sendRequest();

			if (PEAR::isError($response)) {
				//echo $response->getMessage();
			}
			else {
				$ticket = json_decode( $req->getResponseBody() );
			}
		}
		return $ticket;
	}
	
	function get_infos($url) {
		$ret=null;
		if($url) {
			$req = new HTTP_Request($url);
			$req->setMethod(HTTP_REQUEST_METHOD_GET);
//			if($this->ticket!='')
			{
				$req->addHeader("X-Gallery-Request-Key", $this->options['g3_ticket_rest_api']);
			}
			$req->addHeader("X-Gallery-Request-Method", 'get');
		
			$req->sendRequest();
			$ret = json_decode($req->getResponseBody());
		}
		return $ret;
	}

	function get_direct_link($url) {
		$link = '';
		if($url) {
			$continue=true;
			do {
				$info = $this->get_infos($url);
				if($info!=null && isset($info->entity->parent) ) {
					$link = '/' . $info->entity->slug . $link;
					$url = $info->entity->parent;
					$info=null;
				}
				else{
					$continue=false;
				}
			} while( $continue ) ;
		}
		return  $link;
	}

	function test_url($url) {
		$ret = false;
		if($url!=''){
			try {
				$req = new HTTP_Request($url);
				$req->setMethod(HTTP_REQUEST_METHOD_GET);
				$response = $req->sendRequest();
				if (PEAR::isError($response)) {
					return false;
				}
				else
				{
					return true;
				}
			}
			catch (Exception $e){
				$ret = false;
			}
		}
		return $ret;
	}

	function ajax_hg3_test_config_cb() {
		$host='';
		$uri_base='';
		$uri_rest='';
		$ret = '';
		if(isset($_POST['host']) && $_POST['host']!='') {
			$host = $_POST['host'];
			if($this->test_url($host)) {
				if(isset($_POST['guest']) && $_POST['guest']!='') {
					$guest = $_POST['guest'];
					if($guest=='true'){
						if($this->test_url($host.'/rest/item/1')){
						}
						else
							$ret='Guest isn\'t allowed to make restful query on gallery3 ( '.$host.' )' ;
					}
					else {
						$user=$password='';
						if(isset($_POST['user']) && $_POST['user']!='') {
							$user = $_POST['user'];
						}
						if(isset($_POST['password']) && $_POST['password']!='') {
							$password=$_POST['password'];
						}
						if($user!=''){
							$ticket = $this->get_ticket_g3($host.'/rest/',$user,$password);
							if( is_string($ticket)===true && $ticket != '') {
//								$ret = 'ticket : ' . $ticket;
							}
							else{
								$ret = 'Error :'."\n".'Are you sure that the user with the username "' . $user . '" can make restful query on ' . $host . ' ?'."\n\n".'Check the username and the password please and retry this test.';
							}
						}
						else
							$ret = 'Error : User for restful queries must be not null';
					}
				}
				else {
					$ret = 'Error : Data is not certified';
				}
				if($ret=='')
					$ret='Configuration ok';
			}
			else {
				$ret = 'Error : ' . $host . ' is not accessible';
			}
		}
		else {
			$ret = 'The value of "Host" is empty';
		}
		echo $ret;
		die();
	}

	function ajax_hg3_populate_tree_cb() {
		extract(shortcode_atts(array(
			'host'=>$this->options['g3_host'],
			'base_url' => $this->options['g3_baseurl'],
			'base_rest' => $this->options['g3_baserest'],
			'url_base'=>sprintf('%s%s',$this->options['g3_host'],$this->options['g3_baseurl']),
			'target'=>'_blank',
			'id' => '1',
			'width' => $this->options['g3_width'],
			'height' => $this->options['g3_height'],
			'direct_link' => 'none',
			'limit' => 15,
			'start' => 0
		), $attrs));

		if(isset($_POST['id']) && $_POST['id']!='')
			$id = $_POST['id'];
		if(isset($_POST['limit']) && $_POST['limit']!='')
			$limit = $_POST['limit'];
		if(isset($_POST['start']) && $_POST['start']!='')
			$start = $_POST['start'];
		
		$url_base = sprintf('%s%s',$host,$base_url);
		$url = sprintf('%s/rest/item/%d',$host,$id);

		$info = $this->get_infos($url);
		$ret = array();
		if($info){
			$ret['title'] = $info->entity->title;
			$ret['members'] = array();
			$ret['req'] = $id;
			$nb_photos = 0;
			$start_ = $start*$limit;
			$stop = ($start+1)*$limit;
			foreach($info->members as $member){
				$info_tmp = $this->get_infos($member);
				if($info_tmp){
					switch($info_tmp->entity->type){
						case 'album':
							array_push(
								$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
												'title' => $info_tmp->entity->name,
												'type'	=> $info_tmp->entity->type,
												'thumb'	=> $info_tmp->entity->thumb_url)
							);
						break;
						case 'photo':
							if($start_ <= $nb_photos && $nb_photos <$stop){
								array_push(
									$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
													'title' => $info_tmp->entity->name,
													'type'	=> $info_tmp->entity->type,
													'thumb'	=> $info_tmp->entity->thumb_url)
								);
							}
							$nb_photos++;
						break;
					}
				}
			}
			$ret['nb_photos'] = $nb_photos;
			$ret['nb_pages'] = ceil($nb_photos/$limit);
			$ret['pid'] = substr(strrchr($info->entity->parent, '/'), 1);
			$ret['req_p'] = $start;
		}
		else {
			$ret['error']=1;
		}
		$ret = json_encode($ret);
		echo $ret;
		die(); // it is normal to die here for ajax mode
	}
	
	function get_render_album($id,$title,$description,$url_img,$url_direct) {
		return sprintf('
			<div class="imageElement" id="%s">
				<h3>&nbsp;%s</h3>
				<p>%s</p>
				<a href="%s" title="open image" class="open">&nbsp;</a>
				<img src="%s" class="thumbnail" alt="&nbsp;"/>
				<img src="%s" class="full" alt="&nbsp;"/>
			</div>',$id,$title,$description,$url_direct,$url_img,$url_img
		);
	}

	function get_render_photo($title,$description,$url_img,$url_thumb_img,$url_direct) {
		$thumb = $url_thumb_img!=''?sprintf('<img src="%s" class="thumbnail"/>',$url_thumb_img):'';
		$link = sprintf('<a href="%s" class="open"/>',($url_direct==''?'#':$url_direct));
		return sprintf('
			<div class="imageElement">
				<h3>%s</h3>
				<p>&nbsp;%s</p>
				<a href="%s" title="open image" class="open">&nbsp;</a>
				<img src="%s" class="full" />
				%s
			</div>
			',$title,$description,$url_direct,$url_img,$thumb
		);
	}


	function hg3_display($attrs,$content,$code) {
		extract(shortcode_atts(array(
			'host'=>$this->options['g3_host'],
			'base_url' => $this->options['g3_baseurl'],
			'base_rest' => $this->options['g3_baserest'],
			'url_base'=>sprintf('%s%s',$this->options['g3_host'],$this->options['g3_baseurl']),
			'target'=>'_blank',
			'id' => '1',
			'width' => $this->options['g3_width'],
			'height' => $this->options['g3_height'],
			'direct_link' => $this->options['g3_directlink'], 
			'timed' => $this->options['g3_timed'],
			'delay' => $this->options['g3_delay'], // 5000
			'text_caroussel' => $this->options['g3_textCaroussel'],
			'info_pane' => $this->options['g3_infoPane'],
			'show_caroussel' => $this->options['g3_showCaroussel'] 
		), $attrs));

		if(is_numeric($height)){
			$height.='px';
		}
		else {
			$height = $this->options['g3_height'].'px';
		}

		if(is_numeric($width)){
			$width.='px';
		}
		else {
			$width = $this->options['g3_width'].'px';
		}
		if($direct_link=='false' || $direct_link=='true') {
		}
		else {
			$direct_link = isset($this->options['g3_directlink'])?$this->options['g3_directlink']:'false';
		}

		if($text_caroussel=='') {
			$text_caroussel = 'Pictures';
		}

		if($info_pane==='false' || $info_pane==='true') {
		}
		else {
			$info_pane = isset($this->options['g3_infoPane'])?$this->options['g3_infoPane']:'false';
		}

		if($show_caroussel==='false' || $show_caroussel==='true') {
		}
		else {
			$show_caroussel = isset($this->options['g3_showCaroussel'])?$this->options['g3_showCaroussel']:'false';
		}

		if($timed==='false' || $timed==='true') {
		}
		else {
			$timed = isset($this->options['g3_timed'])?$this->options['g3_timed']:'false';
		}

		if(!is_numeric($delay)){
			$width = 5000;
		}
		$str = '';
		$str_css='';

		$url_base = sprintf('%s%s',$host,$base_url);
		$url = sprintf('%s/index.php/rest/item/%d',$host,$id);
		$nomtime=function_exists(microtime);
		$rdm_id = sprintf('%.6s',md5(($nomtime?microtime():time()).rand(0,100)));
		
		$infos = $this->get_infos($url);
		if($infos){
			switch($infos->entity->type){
				case 'album':
					if(sizeof($infos->members)>1 ){
						foreach($infos->members as $member){
							$info = $this->get_infos($member);
							if($info){
								$url_direct = $direct_link=='true' ? $url_base.$this->get_direct_link($info->url):'#';
								if($info->entity->type=='album') {
									$str .= $this->get_render_album(	$info->entity->id,
													$info->entity->title,
													$info->entity->description,
													$info->entity->thumb_url,
													$url_direct
												);
								}
								elseif($info->entity->type=='photo') {
									$str .= $this->get_render_photo(	$info->entity->title,
													$info->entity->description,
													$info->entity->resize_url,
													$info->entity->thumb_url,
													$url_direct
												);
								}
							}
						}
						$str_css .= sprintf($this->pattern_js_gallery,
									'gallery_'.$rdm_id,
									$height,$width,
									$timed,$delay,
									$show_caroussel,$text_caroussel,
									$info_pane
						);
					}
					elseif (sizeof($infos->members)==1) {
						$info = $this->get_infos($infos->members[0]);
						if($info){
							$str_css = sprintf($this->pattern_css_photo,'gallery_'.$rdm_id,$height,$width);
							$url_direct = $direct_link=='true' ? $url_base.$this->get_direct_link($info->url):'#';
							$str .= $this->get_render_photo(	$info->entity->title,
											$info->entity->description . ' ' ,
											$info->entity->resize_url,
											'',
											$url_direct
										);
						}
					}
					else {
						$str = 'Gallerie vide';
					}
					break;
				case 'photo':
					$str_css = sprintf($this->pattern_css_photo,'gallery_'.$rdm_id.'_img',$height,$width);
					$str_img = sprintf('<img src="%s" id="%s_img"/>',$infos->entity->resize_url,'gallery_'.$rdm_id);
					if($direct_link){
						$url_direct = $direct_link=='true' ? $url_base . $this->get_direct_link($infos->url):'#';
						$str = sprintf('<a href="%s" title="%s" target="%s">%s</a>',$url_direct,$infos->entity->title,$this->options['g3_target'],$str_img);
					}
					else {
						$str = $str_img;
					}
					break;
			}
			$str = sprintf('%s<div id="gallery_%s">%s</div>',$str_css,$rdm_id,$str);
		}
		return $str;
	}
	};

if($loading)
	$g3 = new heiv_gallery_3();

?>
